Subject: bug#56334: closed (Re: Should asdf-build-system/sbcl use load-system instead of compile-system?)

From: [email-masked] (GNU bug Tracking System)
Date: Wed, 03 Aug 2022 14:57:02 +0000

Your bug report

#56334: Should asdf-build-system/sbcl use load-system instead of compile-system?

which was filed against the guix package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
56334: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=56334
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: Should asdf-build-system/sbcl use load-system instead of compile-system?
From: Guillaume Le Vaillant <[email-masked]>
To: Pierre Neidhardt <[email-masked]>
Cc: [email-masked]
Date: Wed, 03 Aug 2022 14:49:18 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

Pierre Neidhardt <[email-masked]> skribis:

> I'll be the road for a while, unable to work on this patch, so if anyone
> wants to work on it and merge, please go ahead :)
>
> Left to do:
>
> - Suggestion: add a keyword to choose between asdf:compile-system and
>   asdf:load-system (default should be asdf:load-system).
> - Make sure sbcl-stumpwm-kbd-layouts usees asdf:compile-system.
> - Rebuild the Lisp world to test.

I added a 'asd-operation' keyword parameter with a default value of
"load-system", and I used it in the package definition of
sbcl-stumpwm-kbd-layouts to use "compile-system" instead.

Patches pushed as 6b5ef03a2582ab23228478018fd356e17db1daea and
following.

Subject: Should asdf-build-system/sbcl use load-system instead of compile-system?
From: Pierre Neidhardt <[email-masked]>
To: [email-masked]
Cc: [email-masked]
Date: Fri, 01 Jul 2022 12:16:53 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

While trying to package

    https://github.com/s-expressionists/Cleavir

I hit a strange issue in which it would fail to compile, while calling
`asdf:load-system' locally worked.

Then I realized that our asdf-build-system/sbcl uses
`asdf:compile-system' instead of `asdf:load-system'.

From the ASDF doc:

--8<---------------cut here---------------start------------->8---
This will make sure all the files in the system are compiled, but not
necessarily load any of them in the current image; on most systems, it
will _not_ load all compiled files in the current image.  This function
exists for symmetry with 'load-system' but is not recommended unless you
are writing build scripts and know what you're doing.
--8<---------------cut here---------------end--------------->8---

So should we really use it?

By the way this _may_ be related to the issue we've got with loading the
tests of some packages, like sbcl-jonathan:

--8<---------------cut here---------------start------------->8---
      ;; Tests fail with: Component JONATHAN-ASD::JONATHAN-TEST not found,
      ;; required by #<SYSTEM "jonathan">. Why?
--8<---------------cut here---------------end--------------->8---

Recipe to reproduce:

- git clone https://github.com/s-expressionists/Cleavir
- cd Cleavir
- guix shell sbcl sbcl-acclimation sbcl-concrete-syntax-tree sbcl-closer-mop -- sbcl
- (asdf:initialize-source-registry `(:source-registry (:tree ,(uiop:getcwd)) :inherit-configuration))
- (asdf:compile-system :cleavir-abstract-interpreter)

--8<---------------cut here---------------start------------->8---
debugger invoked on a SB-PCL:CLASS-NOT-FOUND-ERROR in thread
#<THREAD "main thread" RUNNING {100B598173}>:
  There is no class named CLEAVIR-ABSTRACT-INTERPRETER:STRATEGY.

Type HELP for debugger help, or (SB-EXT:EXIT) to exit from SBCL.

restarts (invokable by number or by possibly-abbreviated name):
  0: [TRY-RECOMPILING              ] Recompile control and try loading it again
  1: [RETRY                        ] Retry
                                     loading FASL for #<CL-SOURCE-FILE "cleavir-abstract-interpreter" "control">.
  2: [ACCEPT                       ] Continue, treating
                                     loading FASL for #<CL-SOURCE-FILE "cleavir-abstract-interpreter" "control">
                                     as having been successful.
  3:                                 Retry ASDF operation.
  4: [CLEAR-CONFIGURATION-AND-RETRY] Retry ASDF operation after resetting the
                                     configuration.
  5:                                 Retry ASDF operation.
  6:                                 Retry ASDF operation after resetting the
                                     configuration.
  7: [ABORT                        ] Exit debugger, returning to top level.
--8<---------------cut here---------------end--------------->8---

And then

- (asdf:load-system :cleavir-abstract-interpreter)

works like a charm!

Thoughts?

Pierre